//---------------------------------------------------------------------------
#ifndef PgpSdk6CallsH
#define PgpSdk6CallsH

#include "pgpKeys.h"
#include "pgpErrors.h"
#include "pgpUtilities.h"
#include "pgpSDKPrefs.h"
#include "pgpFeatures.h"
#include "pgpOptionList.h"
#include "pgpMemoryMgr.h"
#include "pgpEncode.h"
#include "pgpRandomPool.h"

//---------------------------------------------------------------------------
#define PGP600 50331648
#define SDK150 50331648

// only functions with option lists need prototypes
PGPOptionListRef PGPOConventionalEncrypt(PGPContextRef Context,
      PGPOptionListRef opt1, PGPOptionListRef opt2, PGPOptionListRef opt3);
PGPError PGPEncode(PGPContextRef context, PGPOptionListRef opt1,
   PGPOptionListRef opt2, PGPOptionListRef opt3, PGPOptionListRef opt4,
   PGPOptionListRef opt5, PGPOptionListRef opt6, PGPOptionListRef opt7,
   PGPOptionListRef opt8, PGPOptionListRef opt9, PGPOptionListRef opt10,
   PGPOptionListRef opt11, PGPOptionListRef opt12, PGPOptionListRef opt13,
   PGPOptionListRef opt14, PGPOptionListRef opt15,
   PGPOptionListRef opt16);
PGPError PGPDecode(PGPContextRef context, PGPOptionListRef opt1, PGPOptionListRef opt2,
   PGPOptionListRef opt3, PGPOptionListRef opt4, PGPOptionListRef opt5,
   PGPOptionListRef opt6, PGPOptionListRef opt7, PGPOptionListRef opt8,
   PGPOptionListRef opt9);
PGPError PGPExport(PGPContextRef context, PGPOptionListRef opt1, PGPOptionListRef opt2,
   PGPOptionListRef opt3, PGPOptionListRef opt4,PGPOptionListRef opt5,
   PGPOptionListRef opt6);
PGPError PGPImportKeySet(PGPContextRef context, PGPKeySetRef *keySet, PGPOptionListRef opt1,
   PGPOptionListRef opt2, PGPOptionListRef opt3, PGPOptionListRef opt4,
   PGPOptionListRef opt5, PGPOptionListRef opt6);
PGPBoolean PGPPassphraseIsValid(PGPKeyRef, PGPOptionListRef, PGPOptionListRef);
PGPOptionListRef PGPOSignWithKey(PGPContextRef context, PGPKeyRef SignKey,
   PGPOptionListRef opt1, PGPOptionListRef opt2, PGPOptionListRef opt3);
PGPError PGPExportKeySet(PGPKeySetRef keySet, PGPOptionListRef opt1, PGPOptionListRef opt2,
   PGPOptionListRef opt3, PGPOptionListRef opt4, PGPOptionListRef opt5);
PGPOptionListRef PGPOSignWithKey(PGPContextRef context, PGPKeyRef SignKey,
   PGPOptionListRef opt1, PGPOptionListRef opt2, PGPOptionListRef opt3);

typedef PGPError (*PGPSDKINIT)(void);
typedef PGPError (*PGPSDKCLEANUP)(void);
typedef PGPError (*PGPNEWCONTEXT)(PGPUInt32, PGPContextRef*);
typedef PGPError (*PGPFREECONTEXT)(PGPContextRef);
typedef PGPError (*PGPSDKLOADDEFAULTPREFS)(PGPContextRef);
typedef PGPError (*PGPSDKPREFGETFILESPEC)(PGPContextRef, PGPsdkPrefSelector, PGPFileSpecRef*);
typedef PGPError (*PGPGETFULLPATHFROMFILESPEC)(PGPFileSpecRef, char**);
typedef PGPError (*PGPGETERRORSTRING)(PGPError, PGPSize, char*);
typedef PGPError (*PGPGETSDKVERSION)(PGPUInt32*);
typedef PGPError (*PGPFREEFILESPEC)(PGPFileSpecRef fileRef);
typedef PGPError (*PGPEXPORTKEYSET)(PGPKeySetRef, PGPOptionListRef, PGPOptionListRef,
      PGPOptionListRef, PGPOptionListRef, PGPOptionListRef);
typedef PGPError (*PGPFREEKEYSET)(PGPKeySetRef);
typedef PGPError (*PGPIMPORTKEYSET)(PGPContextRef, PGPKeySetRef *keySet, PGPOptionListRef,
   PGPOptionListRef, PGPOptionListRef, PGPOptionListRef, PGPOptionListRef,
   PGPOptionListRef);
typedef PGPError (*PGPFREEDATA)(void *allocation);
typedef PGPError (*PGPOPENDEFAULTKEYRINGS)(PGPContextRef, PGPKeyRingOpenFlags, PGPKeySetRef*);
typedef PGPError (*PGPNEWKEYDISABLEDFILTER)(PGPContextRef, PGPBoolean, PGPFilterRef*);
typedef PGPError (*PGPNEWKEYREVOKEDFILTER)(PGPContextRef, PGPBoolean, PGPFilterRef*);
typedef PGPError (*PGPFILTERKEYSET)(PGPKeySetRef, PGPFilterRef, PGPKeySetRef*);
typedef PGPError (*PGPORDERKEYSET)(PGPKeySetRef, PGPKeyOrdering, PGPKeyListRef*);
typedef PGPError (*PGPNEWKEYITER)(PGPKeyListRef, PGPKeyIterRef*);
typedef PGPError (*PGPKEYITERSUBKEY)(PGPKeyIterRef, PGPSubKeyRef*);
typedef PGPError (*PGPGETHASHALGUSED)(PGPKeyRef key, PGPHashAlgorithm *hashAlg );
typedef PGPError (*PGPGETKEYIDFROMKEY)(PGPKeyRef, PGPKeyID*);
typedef PGPError (*PGPGETKEYIDFROMSUBKEY)(PGPSubKeyRef subKey, PGPKeyID *keyID);
typedef PGPError (*PGPGETSUBKEYNUMBER)(PGPSubKeyRef, PGPKeyPropName, PGPInt32*);
typedef PGPError (*PGPGETKEYIDFROMSTRING)(const char*, PGPKeyID*);
typedef PGPError (*PGPGETKEYIDSTRING)(PGPKeyID const*, PGPKeyIDStringType,
   char[kPGPMaxKeyIDStringSize]);
typedef PGPError (*PGPKEYITERNEXT)(PGPKeyIterRef, PGPKeyRef*);
typedef PGPError (*PGPFREEKEYITER)(PGPKeyIterRef);
typedef PGPError (*PGPFREEKEYLIST)(PGPKeyListRef);
typedef PGPError (*PGPFREEFILTER)(PGPFilterRef);
typedef PGPError (*PGPNEWFILESPECFROMFULLPATH)(PGPContextRef, const char*, PGPFileSpecRef*);
typedef PGPError (*PGPOPENKEYRING)(PGPContextRef, PGPKeyRingOpenFlags, PGPFileSpecRef,
   PGPKeySetRef*);
typedef PGPError (*PGPGETKEYBYKEYID)(PGPKeySetRef, PGPKeyID const*, PGPPublicKeyAlgorithm,
   PGPKeyRef*);
typedef PGPError (*PGPDECODESIG)(PGPContextRef context, PGPOptionListRef, PGPOptionListRef,
   PGPOptionListRef, PGPOptionListRef, PGPOptionListRef);
typedef PGPError (*PGPDECODE)(PGPContextRef context, PGPOptionListRef, PGPOptionListRef,
   PGPOptionListRef, PGPOptionListRef, PGPOptionListRef, PGPOptionListRef,
   PGPOptionListRef, PGPOptionListRef, PGPOptionListRef);
typedef PGPError (*PGPENCODE)(PGPContextRef context, PGPOptionListRef, PGPOptionListRef,
   PGPOptionListRef, PGPOptionListRef, PGPOptionListRef, PGPOptionListRef,
   PGPOptionListRef, PGPOptionListRef, PGPOptionListRef, PGPOptionListRef,
   PGPOptionListRef, PGPOptionListRef, PGPOptionListRef, PGPOptionListRef,
   PGPOptionListRef, PGPOptionListRef);
typedef PGPError (*PGPGETPRIMARYUSERID)(PGPKeyRef, PGPUserIDRef*);
typedef PGPError (*PGPGETUSERIDSTRINGBUFFER)(PGPUserIDRef, PGPUserIDPropName, PGPSize,
   char*, PGPSize*);
typedef PGPError (*PGPOPENKEYRINGPAIR)(PGPContextRef, PGPKeyRingOpenFlags, PGPFileSpecRef,
   PGPFileSpecRef, PGPKeySetRef*);
typedef PGPError (*PGPGETKEYNUMBER)(PGPKeyRef, PGPKeyPropName, PGPInt32*);
typedef PGPError (*PGPGETKEYBOOLEAN)(PGPKeyRef, PGPKeyPropName, PGPBoolean*);
typedef PGPError (*PGPCOUNTADDITIONALRECIPIENTREQUESTS)(PGPKeyRef, PGPUInt32*);
typedef PGPError (*PGPNEWKEYSET)(PGPContextRef, PGPKeySetRef*);
typedef PGPError (*PGPNEWSINGLETONKEYSET)(PGPKeyRef, PGPKeySetRef*);
typedef PGPError (*PGPADDKEYS)(PGPKeySetRef, PGPKeySetRef);
typedef PGPError (*PGPCOMMITKEYRINGCHANGES)(PGPKeySetRef);
typedef PGPError (*PGPNEWEMPTYKEYSET)(PGPKeySetRef, PGPKeySetRef*);
typedef PGPError (*PGPNEWUSERIDEMAILFILTER)(PGPContextRef, const char*,
   PGPMatchCriterion, PGPFilterRef*);
typedef PGPUInt32 (*PGPGLOBALRANDOMPOOLMOUSEMOVED)();
typedef PGPError (*PGPCOUNTKEYS)(PGPKeySetRef, PGPUInt32*);
typedef PGPError (*PGPCONTEXTGETRANDOMBYTES)(PGPContextRef, void*, PGPSize);
typedef PGPOptionListRef (*PGPOEXPORTFORMAT)(PGPContextRef, PGPExportFormat);
typedef PGPOptionListRef (*PGPOEXPORTPRIVATEKEYS)(PGPContextRef, PGPBoolean);
typedef PGPOptionListRef (*PGPOVERSIONSTRING)(PGPContextRef, const char*);
typedef PGPOptionListRef (*PGPOLASTOPTION)(PGPContextRef);
typedef PGPOptionListRef (*PGPOALLOCATEDOUTPUTBUFFER)(PGPContextRef, void**, PGPSize,
   PGPSize*);
typedef PGPOptionListRef (*PGPOINPUTFILE)(PGPContextRef, PGPFileSpecRef);
typedef PGPOptionListRef (*PGPOINPUTBUFFER)(PGPContextRef, void const*, PGPSize);
typedef PGPOptionListRef (*PGPOKEYSETREF)(PGPContextRef context, PGPKeySetRef keysetRef);
typedef PGPOptionListRef (*PGPOEVENTHANDLER)(PGPContextRef, PGPEventHandlerProcPtr,
   PGPUserValue);
typedef PGPOptionListRef (*PGPORECURSIVELYDECODE)(PGPContextRef, PGPBoolean);
typedef PGPOptionListRef (*PGPOPASSPHRASE)(PGPContextRef, const char*);
typedef PGPOptionListRef (*PGPOCLEARSIGN)(PGPContextRef, PGPBoolean);
typedef PGPOptionListRef (*PGPOSIGNWITHKEY)(PGPContextRef, PGPKeyRef, PGPOptionListRef,
   PGPOptionListRef, PGPOptionListRef);
typedef PGPOptionListRef (*PGPOCOMPRESSION)(PGPContextRef, PGPBoolean);
typedef PGPOptionListRef (*PGPOARMOROUTPUT)(PGPContextRef, PGPBoolean);
typedef PGPOptionListRef (*PGPOENCRYPTTOKEYSET)(PGPContextRef,PGPKeySetRef);
typedef PGPOptionListRef (*PGPOCONVENTIONALENCRYPT)(PGPContextRef,
   PGPOptionListRef, PGPOptionListRef, PGPOptionListRef);
typedef PGPOptionListRef (*PGPOOUTPUTLINEENDTYPE)(PGPContextRef, PGPLineEndType);
typedef PGPOptionListRef (*PGPODDATAISSCII)(PGPContextRef,PGPBoolean);
typedef PGPOptionListRef (*PGPOFORYOUREYESONLY)(PGPContextRef, PGPBoolean);
typedef PGPOptionListRef (*PGPOHASHALGORITHM)(PGPContextRef, PGPHashAlgorithm);
typedef PGPOptionListRef (*PGPOASKUSERFORENTROPY)(PGPContextRef, PGPBoolean);
typedef PGPError (*PGPGETPRIMARYUSERIDNAMEBUFFER)(PGPKeyRef, PGPSize, char*, PGPSize*);
typedef PGPBoolean (*PGPPASSPHRASEISVALID)(PGPKeyRef, PGPOptionListRef, PGPOptionListRef);
typedef time_t (*PGPGETSTDTIMEFROMPGPTIME)(PGPTime);
typedef PGPTime (*PGPGETTIME)();

void __fastcall ShowPGPError(PGPError err, AnsiString errmsg);
bool __fastcall IsPgpError(PGPError err, const AnsiString &errmsg);
PGPError DecodeEventHandler(PGPContextRef context, PGPEvent *event, PGPUserValue userValue);
AnsiString __fastcall GetTok(const int pos, const AnsiString line, const char div,
   const AnsiString &def);
AnsiString __fastcall TimeT2SigTime(time_t thetime);

struct Tdecinfo6 {
   PGPKeySetRef keySet;
   TStrings *siginfos;
   int decrypts;
   int sigs;
};

/*
* SDK API version
* example: 1.0.0 = 0x01000000
*   0x01000000   (16777216)   SDK 1.0.0   PGP550
*   0x02000000   (33554432)   SDK 1.1.0
*   0x02000010   (33554448)   SDK 1.1.1   PGP553
*   0x03000000   (50331648)   SDK 1.5.0   PGP600
*   0x03000010   (50331664)   SDK 1.5.1
*   0x03000020   (50331680)   SDK 1.5.2   PGP602
*   0x03001000   (50335744)   SDK 1.6.0
*   0x03002000   (50339840)   SDK 1.7.0   PGP650
*   0x03002010   (50339856)   SDK 1.7.1   PGP651,2,3
*   0x--------   (50339856)   SDK 1.7.8   PGP658
*   0x03000000   (50331648)   SDK 3.0.0
*/
//---------------------------------------------------------------------------
extern HANDLE hSdkLib6;
extern PGPContextRef context;
extern PGPError err6;
//---------------------------------------------------------------------------
#endif
