//---------------------------------------------------------------------------
#include <basepch.h>
#pragma hdrstop
#include <registry.hpp>
#include <inifiles.hpp>

#include "PgpSdk.h"
#include "PgpSdk6.h"
#include "PgpSdk8.h"
#include "Global2.h"

USEFORM("PGPKeyringSelDlgs.cpp", PGPKeyringSelDlg);
USEFORM("PGPFixDirDlgs.cpp", PGPFixDirDlg);
//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
// initialization
//---------------------------------------------------------------------------

TPGPsdk* __fastcall PGPInit(TForm *Owner)
{
   PGPsdk = PGPInitV8(Owner, "", "", "");
   if (PGPsdk == NULL)
      PGPsdk = PGPInitV6(Owner, "", "", "");

   MixmasterDir = MixDir();
   return PGPsdk;
}
//---------------------------------------------------------------------------

AnsiString __fastcall PGPPublicRing()
{
   AnsiString name;
   /*TRegistry *reg = new TRegistry();
   try
   {
      if (reg->OpenKey(QuickSilverRegKey, false))
      {
         name = reg->ReadString(PGPPublicRegKey);
         reg->CloseKey();
      }
   }
   catch (...)
   {
   }
   delete reg;*/

   if (name.IsEmpty())
   {
      TIniFile *ini = new TIniFile(AppDir() + "QSpgp.ini");
      name = ini->ReadString(PgpIni, "pubring", "");
      if (name.IsEmpty())
      {
         if (FileExists(AppDir() + "pubring.pkr"))
         {
            name = AppDir() + "pubring.pkr";
            ini->WriteString(PgpIni, "pubring", name);
         }
      }
      delete ini;
   }

   return name;
}
//---------------------------------------------------------------------------

AnsiString __fastcall PGPSecretRing()
{
   AnsiString name;
   /*TRegistry *reg = new TRegistry();
   try
   {
      if (reg->OpenKey(QuickSilverRegKey, false))
      {
         name = reg->ReadString(PGPSecretRegKey);
         reg->CloseKey();
      }
   }
   catch (...)
   {
   }
   delete reg;*/

   if (name.IsEmpty())
   {
      TIniFile *ini = new TIniFile(AppDir() + "QSpgp.ini");
      name = ini->ReadString(PgpIni, "secring", "");
      if (name.IsEmpty())
      {
         if (FileExists(AppDir() + "secring.skr"))
         {
            name = AppDir() + "secring.skr";
            ini->WriteString(PgpIni, "secring", name);
         }
      }
      delete ini;
   }

   return name;
}
//---------------------------------------------------------------------------

AnsiString __fastcall PGPRemailerRing()
{
   AnsiString name = MixDir() + "pubring.asc";
   if (!FileExists(name))
      name = "";

   return name;
}
//---------------------------------------------------------------------------

AnsiString __fastcall PGPNymserverRing()
{
   AnsiString name = AppDir() + NymserverFile;
   if (!FileExists(name))
      name = "";

   return name;
}

//---------------------------------------------------------------------------
//   Package source.
//---------------------------------------------------------------------------

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
   return 1;
}
//---------------------------------------------------------------------------
