//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "PGPwins.h"
#include "PGPsdk.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPGPwin *PGPwin;
//---------------------------------------------------------------------------

__fastcall TPGPwin::TPGPwin(TComponent* Owner)
        : TForm(Owner)
{
   if (ParamCount > 0)
      FileName->Text = ParamStr(1);

   if (!FileExists(FileName->Text))
   {
      AnsiString errormsg = "The file '" + FileName->Text + "' doesn't exist!";
      MessageBox(NULL, errormsg.c_str(), "Error", MB_OK);
      PostMessage(Handle, WM_QUIT, 0, 0);
      return;
   }

   PGP = PGPInit(this);
   if (!PGP || !PGP->InitSuccess)
   {
      AnsiString errormsg = "I failed to initialize the PGP sdk!";
      MessageBox(NULL, errormsg.c_str(), "Error", MB_OK);
      PostMessage(Handle, WM_QUIT, 0, 0);
      delete PGP;
      return;
   }

   Display->Lines->LoadFromFile(FileName->Text);

   for (int i = 2; i <= ParamCount(); i++)
   {
      AnsiString param = ParamStr(i).LowerCase();

      if (param.Pos("-s") == 1)
      {
         AnsiString data = param.SubString(3, 128);
         int x = data.Pos(":");
         SignKey->Text = data.SubString(1, x - 1);
         password = data.SubString(x + 1, 128);
         continue;
      }

      if (param == "-m")
      {
         MsgBox->Checked = true;
         continue;
      }
   }
}
//---------------------------------------------------------------------------

__fastcall TPGPwin::~TPGPwin()
{
   delete PGP;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPwin::ClearSign()
{

   return true;
}
//---------------------------------------------------------------------------

void __fastcall TPGPwin::Exit1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
